VERSION 2.00
Begin Form RAND_COND 
   Caption         =   "Random Initial Conditions"
   ClientHeight    =   4635
   ClientLeft      =   -45
   ClientTop       =   1275
   ClientWidth     =   9600
   ControlBox      =   0   'False
   Height          =   5040
   Left            =   -105
   LinkTopic       =   "Form2"
   MinButton       =   0   'False
   ScaleHeight     =   4635
   ScaleWidth      =   9600
   Top             =   930
   Width           =   9720
   Begin Frame Frame4 
      Caption         =   "Fourier Transform "
      Height          =   2895
      Left            =   4920
      TabIndex        =   14
      Top             =   1560
      Width           =   4575
      Begin GRAPH Graph2 
         BorderStyle     =   0  'None
         GraphType       =   6  'Line
         Height          =   2535
         Left            =   120
         RandomData      =   0  'Off
         TabIndex        =   16
         ThickLines      =   0  'Off
         Top             =   240
         Width           =   4335
         YAxisStyle      =   1  'Variable Origin
      End
   End
   Begin Frame Frame3 
      Caption         =   "Sequence"
      Height          =   2895
      Left            =   120
      TabIndex        =   13
      Top             =   1560
      Width           =   4695
      Begin GRAPH Graph1 
         AutoInc         =   0  'Off
         BorderStyle     =   0  'None
         GraphStyle      =   2
         GraphType       =   6  'Line
         Height          =   2535
         Left            =   120
         RandomData      =   0  'Off
         TabIndex        =   15
         ThickLines      =   0  'Off
         Top             =   240
         Width           =   4455
         YAxisStyle      =   1  'Variable Origin
      End
   End
   Begin HScrollBar HScroll1 
      Height          =   255
      LargeChange     =   2
      Left            =   5280
      Max             =   14
      Min             =   8
      TabIndex        =   12
      Top             =   960
      Value           =   10
      Width           =   2175
   End
   Begin CommandButton Cancel 
      Caption         =   "&Cancel"
      Height          =   375
      Left            =   8160
      TabIndex        =   11
      Top             =   600
      Width           =   855
   End
   Begin CommandButton Ok 
      Caption         =   "&Ok"
      Height          =   375
      Left            =   8160
      TabIndex        =   10
      Top             =   120
      Width           =   855
   End
   Begin CommandButton Verifica 
      Caption         =   "&Verify"
      Default         =   -1  'True
      Height          =   375
      Left            =   8160
      TabIndex        =   9
      Top             =   1080
      Width           =   855
   End
   Begin TextBox Text1 
      Height          =   285
      Left            =   6360
      TabIndex        =   8
      Top             =   165
      Width           =   1095
   End
   Begin Frame Frame2 
      Caption         =   "Verify Method"
      Height          =   1095
      Left            =   2640
      TabIndex        =   1
      Top             =   120
      Width           =   2415
      Begin OptionButton Option4 
         Caption         =   "Autocorelation"
         Height          =   255
         Left            =   120
         TabIndex        =   5
         Top             =   720
         Width           =   2175
      End
      Begin OptionButton Option3 
         Caption         =   "FFT"
         Height          =   255
         Left            =   120
         TabIndex        =   4
         Top             =   360
         Value           =   -1  'True
         Width           =   2175
      End
   End
   Begin Frame Frame1 
      Caption         =   "Generator Style"
      Height          =   1095
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2415
      Begin OptionButton Option2 
         Caption         =   "Generator + FFT"
         Height          =   255
         Left            =   120
         TabIndex        =   3
         Top             =   720
         Width           =   2055
      End
      Begin OptionButton Option1 
         Caption         =   "Computer generator"
         Height          =   255
         Left            =   120
         TabIndex        =   2
         Top             =   360
         Value           =   -1  'True
         Width           =   2055
      End
   End
   Begin Label Label3 
      AutoSize        =   -1  'True
      Caption         =   "1024"
      Height          =   195
      Left            =   6840
      TabIndex        =   17
      Top             =   600
      Width           =   435
   End
   Begin Label Label2 
      AutoSize        =   -1  'True
      Caption         =   "No. of samples = "
      Height          =   195
      Left            =   5280
      TabIndex        =   7
      Top             =   600
      Width           =   1500
   End
   Begin Label Label1 
      AutoSize        =   -1  'True
      Caption         =   "Amplitude = "
      Height          =   195
      Left            =   5280
      TabIndex        =   6
      Top             =   240
      Width           =   1065
   End
End
Option Explicit
Dim tip_verif As Integer
Const four = 0
Const corel = 1
Dim transf() As Single
Dim corelat() As Single
Dim k As Integer
Dim w_real, w_imag, temp_r, temp_i As Double

Sub Cancel_Click ()
    Unload RAND_COND
End Sub

Sub FFT_invers ()
          'generarea secventei cu FFT
          ReDim put_2(Nput2)
          For i = 0 To Nput2 - 1
              put_2(i) = 2 ^ i
          Next i
          'Calculare FFT inversa
          For i = 0 To Nput2 - 1
             n = put_2(i)
             m = 2 * n
          For j = 0 To nr_esant - 1 Step m
             For k = 1 To n - 1
              w_real = Cos(CDbl(k * pi) / n)
              w_imag = Sin(CDbl(k * pi) / n)
              temp_r = transform(0, j + k + n) * w_real - transform(1, j + k + n) * w_imag
              temp_i = transform(1, j + k + n) * w_real + transform(0, j + k + n) * w_imag
              transform(0, j + k) = transform(0, j + k) + temp_r
              transform(1, j + k) = transform(1, j + k) + temp_i
              transform(0, j + k + n) = transform(0, j + k) - 2 * temp_r
              transform(1, j + k + n) = transform(1, j + k) - 2 * temp_i
             Next k
            Next j
          Next i
End Sub

Sub fixat_Click ()
    fixat.Show 1
End Sub

Sub Form_Load ()
    tip_verif = four
    nr_esant = 256
    Nput2 = 8
    Text1.Text = ampl_max
End Sub

Sub HScroll1_Change ()
    label3.Caption = 2 ^ HScroll1.Value
    nr_esant = 2 ^ HScroll1.Value
    Nput2 = HScroll1.Value
End Sub

Sub Ok_Click ()
    ampl_max = Text1.Text
    Unload RAND_COND
End Sub

Sub option1_click ()
    tip_rand = computer
End Sub

Sub option2_click ()
    tip_rand = FFT
End Sub

Sub option3_click ()
    tip_verif = four
    frame4.Caption = "Fourier Transform"
End Sub

Sub option4_click ()
   tip_verif = corel
   frame4.Caption = "Autocorelation"
End Sub

Sub Verifica_Click ()
Dim pas As Integer
Dim put_2() As Integer
    If nr_esant > 1024 Then
       pas = nr_esant / 1024
    Else
       pas = 1
    End If
    Randomize
    If tip_verif = four Then
       If tip_rand = FFT Then
          ReDim secventa(nr_esant)
          ReDim transform(2, nr_esant)
          Randomize
          For i = 1 To nr_esant / 2
              temp_s = (Rnd - .5) * pi * 2
              transform(0, i) = Cos(temp_s)
              transform(1, i) = Sin(temp_s)
          Next i
          For i = 1 To nr_esant / 2 - 1
              transform(0, nr_esant - i) = transform(0, i)
              transform(1, nr_esant - i) = -transform(1, i)
          Next i
          transform(0, 0) = 0
          transform(1, 0) = 0
          transform(0, nr_esant / 2) = 0
          transform(1, nr_esant / 2) = 0
          graph2.AutoInc = 0
          graph2.NumPoints = nr_esant / pas
          For i = 0 To graph2.NumPoints - 1
            graph2.ThisPoint = i + 1
            graph2.XPosData = i * pas
            graph2.GraphData = Sqr(transform(0, i) ^ 2 + transform(1, i) ^ 2)
          Next i
          Call FFT_invers
          graph1.AutoInc = 0
          graph1.NumPoints = nr_esant / pas
          For i = 0 To graph1.NumPoints - 1
              graph1.ThisPoint = i + 1
              graph1.XPosData = i * pas
              graph1.GraphData = transform(0, i)
              secventa(i) = transform(0, i)
          Next i
       'sfirsit generare
       ElseIf tip_rand = computer Then
          'generarea secventei cu rnd
          ReDim secventa(nr_esant)
          graph1.AutoInc = 0
          graph1.NumPoints = nr_esant / pas
          For i = 0 To nr_esant - 1
              secventa(i) = 1 * (Rnd - .5)
          Next i
          For i = 0 To graph1.NumPoints - 1
              graph1.ThisPoint = i + 1
              graph1.XPosData = i * pas
              graph1.GraphData = secventa(i)
          Next i
       'calcularea Fourier
       ReDim transform(2, nr_esant)
       ReDim put_2(Nput2)
       For i = 0 To nr_esant - 1
         transform(0, i) = 0
         transform(1, i) = 0
       Next i
       For i = 0 To Nput2 - 1
          put_2(i) = 2 ^ i
       Next i
       Dim suma As Integer
       For i = 0 To nr_esant - 1
           For j = 0 To Nput2 - 1
               suma = 0
               temp_i = i
               If temp_i >= put_2(Nput2 - j - 1) Then
                  suma = suma + put_2(j)
                  temp_i = temp_i - put_2(Nput2 - j - 1)
               End If
           Next j
       transform(0, i) = secventa(suma)
       Next i
       'Calculare FFT
       For i = 0 To Nput2 - 1
           n = put_2(i)
           m = 2 * n
       For j = 0 To nr_esant - 1 Step m
           transform(0, j) = transform(0, j) + transform(0, j + n)
           transform(1, j) = transform(1, j) + transform(1, j + n)
           transform(0, j + n) = transform(0, j) - transform(0, j + n) - transform(0, j + n)
           transform(1, j + n) = transform(1, j) - transform(1, j + n) - transform(1, j + n)
           'Jumatate FFT in pasul curent
           For k = 1 To n - 1
              w_real = Cos(CDbl(k * pi) / n)
              w_imag = -Sin(CDbl(k * pi) / n)
              transform(0, j + k) = transform(0, j + k) + transform(0, j + k + n) * w_real - transform(1, j + k + n) * w_imag
              transform(1, j + k) = transform(1, j + k) + transform(1, j + k + n) * w_real + transform(0, j + k + n) * w_imag
           Next k
           'Cealalta jumatate -> transpunere
           For k = 1 To n - 1
              transform(0, m - k + j) = transform(0, j + k)
              transform(1, m - k + j) = -transform(1, j + k)
           Next k
       Next j
       Next i
       graph2.AutoInc = 0
       graph2.NumPoints = nr_esant / pas
       For i = 1 To graph2.NumPoints - 1
           graph2.ThisPoint = i + 1
           graph2.XPosData = i * pas
           graph2.GraphData = Sqr(transform(0, i) ^ 2 + transform(1, i) ^ 2)
       Next i
    'sfirsit
     End If
    ElseIf tip_verif = corel Then
       ReDim corelat(nr_esant)
       If tip_rand = FFT Then
           'generarea secventei cu FFT
          ReDim secventa(nr_esant)
          ReDim transform(2, nr_esant)
          Randomize
          For i = 0 To nr_esant - 1
              temp_s = (Rnd - .5) * pi
              transform(0, i) = Cos(temp_s)
              transform(1, i) = Sin(temp_s)
          Next i
          Call FFT_invers
          graph1.AutoInc = 0
          graph1.NumPoints = nr_esant / pas
          For i = 0 To graph1.NumPoints - 1
              graph1.ThisPoint = i + 1
              graph1.XPosData = i * pas
              graph1.GraphData = transform(0, i)
              secventa(i) = transform(0, i)
          Next i
       'sfirsit generare
       ElseIf tip_rand = computer Then
           'generarea secventei cu rnd
          graph1.AutoInc = 0
          ReDim secventa(nr_esant)
          graph1.NumPoints = nr_esant / pas
          For i = 0 To nr_esant - 1
              secventa(i) = 1 * (Rnd - .5)
          Next i
          For i = 0 To graph1.NumPoints - 1
              graph1.ThisPoint = i + 1
              graph1.XPosData = i * pas
              graph1.GraphData = secventa(i)
          Next i
          'sfirsit
       End If
       'calcularea corelatiei
       For i = 0 To nr_esant - 1
           corelat(i) = 0
           For j = 0 To nr_esant - 1
               If i + j > nr_esant - 1 Then
                  temp_i = i + j - nr_esant
               Else
                  temp_i = i + j
               End If
               corelat(i) = corelat(i) + secventa(j) * secventa(temp_i)
           Next j
       Next i
          graph2.AutoInc = 0
          graph2.NumPoints = nr_esant / pas
          For i = 0 To graph2.NumPoints - 1
            graph2.ThisPoint = i + 1
            graph2.XPosData = i * pas
            graph2.GraphData = Abs(corelat(i))
          Next i
    End If
    graph1.DrawMode = 2
    graph2.DrawMode = 2
End Sub

