VERSION 2.00
Begin Form Valori 
   Caption         =   "Eigenvalues"
   ClientHeight    =   2880
   ClientLeft      =   1245
   ClientTop       =   3015
   ClientWidth     =   6195
   ControlBox      =   0   'False
   Height          =   3285
   Left            =   1185
   LinkTopic       =   "Form3"
   MinButton       =   0   'False
   ScaleHeight     =   2880
   ScaleWidth      =   6195
   Top             =   2670
   Width           =   6315
   Begin Frame Frame1 
      Caption         =   "Eigenvalues in band"
      Height          =   2655
      Left            =   240
      TabIndex        =   1
      Top             =   120
      Width           =   4815
      Begin ListBox temporal 
         Height          =   1200
         Left            =   3000
         TabIndex        =   7
         Top             =   1080
         Width           =   1575
      End
      Begin ListBox spatial 
         Height          =   1200
         Left            =   240
         TabIndex        =   6
         Top             =   1080
         Width           =   2055
      End
      Begin Label Label6 
         AutoSize        =   -1  'True
         Caption         =   "Label6"
         Height          =   195
         Left            =   3000
         TabIndex        =   9
         Top             =   840
         Width           =   585
      End
      Begin Label Label5 
         AutoSize        =   -1  'True
         Caption         =   "Label5"
         Height          =   195
         Left            =   240
         TabIndex        =   8
         Top             =   840
         Width           =   585
      End
      Begin Label Label4 
         AutoSize        =   -1  'True
         Caption         =   "maximum = "
         Height          =   195
         Left            =   3000
         TabIndex        =   5
         Top             =   600
         Width           =   990
      End
      Begin Label Label3 
         AutoSize        =   -1  'True
         Caption         =   "m   n     value"
         Height          =   195
         Left            =   240
         TabIndex        =   4
         Top             =   600
         Width           =   1200
      End
      Begin Label Label2 
         AutoSize        =   -1  'True
         Caption         =   "temporal"
         FontBold        =   -1  'True
         FontItalic      =   0   'False
         FontName        =   "MS Sans Serif"
         FontSize        =   8.25
         FontStrikethru  =   0   'False
         FontUnderline   =   -1  'True
         Height          =   195
         Left            =   3120
         TabIndex        =   3
         Top             =   360
         Width           =   735
      End
      Begin Label Label1 
         AutoSize        =   -1  'True
         Caption         =   "spatial"
         FontBold        =   -1  'True
         FontItalic      =   0   'False
         FontName        =   "MS Sans Serif"
         FontSize        =   8.25
         FontStrikethru  =   0   'False
         FontUnderline   =   -1  'True
         Height          =   195
         Left            =   360
         TabIndex        =   2
         Top             =   360
         Width           =   570
      End
   End
   Begin CommandButton Ok_val 
      Caption         =   "&Ok"
      Height          =   375
      Left            =   5160
      TabIndex        =   0
      Top             =   1080
      Width           =   855
   End
End
Option Explicit
Dim poz() As Integer
Dim pozinv() As Integer

Function Disp (ByVal x As Single) As Single
    Dim re, rad1 As Single
    re = gama * (dfdu + dgdv) / 2 - x * (Du + Dv) / 2
    rad1 = (gama * (dgdv - dfdu) / 2 + x * (Du - Dv) / 2) ^ 2 + gama * gama * dfdv * dgdu
    If rad1 > 0 Then
       re = re + Sqr(rad1)
    End If
    Disp = re
End Function

Sub Form_Load ()
Dim max, valoare, curent, urmator As Single
On Error GoTo errorhand
    If Not psf_calculat Then
       calcul_psf
    End If
    max = 0
    Screen.MousePointer = 11
    If tip_retea = vect And cond_front = zero_flux Then
       For i = 0 To M - 1
           valoare = 4 * (Sin(i * pi / 2 / M)) ^ 2
           If valoare > k1 And valoare < k2 Then
           temp_str = i & "   "
           If i < 10 Then
              temp_str = temp_str & "  "
           End If
           temp_str = temp_str & CStr(Format$(valoare, "##0.00000"))
           spatial.AddItem temp_str
           temporal.AddItem CStr(Format$(Disp(valoare), "##0.00000"))
           If max < Disp(valoare) Then
              max = Disp(valoare)
           End If
           End If
       Next i
    ElseIf tip_retea = vect And cond_front = periodic Then
       For i = 0 To M - 1
           valoare = 4 * (Sin(i * pi / M)) ^ 2
           If valoare > k1 And valoare < k2 Then
           temp_str = i & "   "
           If i < 10 Then
              temp_str = temp_str & "  "
           End If
           temp_str = temp_str & CStr(Format$(valoare, "##0.00000"))
           spatial.AddItem temp_str
           temporal.AddItem CStr(Format$(Disp(valoare), "##0.00000"))
           If max < Disp(valoare) Then
              max = Disp(valoare)
           End If
           End If
       Next i
    ElseIf tip_retea = arr And cond_front = zero_flux Then
        For i = 0 To M - 1
            For j = 0 To N - 1
                valoare = 4 * ((Sin(i * pi / 2 / M)) ^ 2 + (Sin(j * pi / 2 / N)) ^ 2)
                If valoare > k1 And valoare < k2 Then
                temp_str = i & "  "
                If i < 10 Then
                    temp_str = temp_str & "  "
                End If
                temp_str = temp_str & j & "  "
                If j < 10 Then
                    temp_str = temp_str & "  "
                End If
                temp_str = temp_str & CStr(Format$(valoare, "##0.00000"))
                spatial.AddItem temp_str
                temporal.AddItem CStr(Format$(Disp(valoare), "##0.00000"))
                If max < Disp(valoare) Then
                  max = Disp(valoare)
                End If
                End If
            Next j
        Next i
    ElseIf tip_retea = arr And cond_front = periodic Then
        For i = 0 To M - 1
            For j = 0 To N - 1
                valoare = 4 * ((Sin(i * pi / M)) ^ 2 + (Sin(j * pi / N)) ^ 2)
                If valoare > k1 And valoare < k2 Then
                temp_str = i & "  "
                If i < 10 Then
                    temp_str = temp_str & "  "
                End If
                temp_str = temp_str & j & "  "
                If j < 10 Then
                    temp_str = temp_str & "  "
                End If
                temp_str = temp_str & CStr(Format$(valoare, "##0.00000"))
                spatial.AddItem temp_str
                temporal.AddItem CStr(Format$(Disp(valoare), "##0.00000"))
                If max < Disp(valoare) Then
                  max = Disp(valoare)
                End If
                End If
            Next j
        Next i
    End If
    ReDim poz(temporal.ListCount)
    For i = 0 To temporal.ListCount - 1
        poz(i) = i
    Next i
    Dim flag As Integer
    flag = 1
    While flag = 1
       flag = 0
       For i = 0 To temporal.ListCount - 2
           curent = temporal.List(i)
           urmator = temporal.List(i + 1)
           If curent < urmator Then
              temp_str = temporal.List(i)
              temporal.List(i) = temporal.List(i + 1)
              temporal.List(i + 1) = temp_str
              temp_i = poz(i)
              poz(i) = poz(i + 1)
              poz(i + 1) = temp_i
              flag = 1
           End If
       Next i
    Wend
    ReDim pozinv(temporal.ListCount)
    For i = 0 To temporal.ListCount - 1
        pozinv(poz(i)) = i
    Next i
    Screen.MousePointer = 0
    label4.Caption = label4.Caption & CStr(Format$(max, "##0.00000"))
    label6.Caption = ""
    label5.Caption = ""
    Exit Sub
errorhand:
    MsgBox "Too many eigenvalues!", 0 + 48
    Exit Sub
End Sub

Sub Ok_val_Click ()
If tip_l Then
    valori.Hide
Else
    Unload valori
End If
End Sub

Sub spatial_Click ()
    label6.Caption = temporal.List(pozinv(spatial.ListIndex))
    label5.Caption = spatial.List(spatial.ListIndex)
End Sub

Sub temporal_Click ()
    label5.Caption = spatial.List(poz(temporal.ListIndex))
    label6.Caption = temporal.List(temporal.ListIndex)
End Sub

